import { __extends } from 'tslib';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function ConfigAspect() { }
if (false) {
    /**
     * @param {?} id
     * @return {?}
     */
    ConfigAspect.prototype.getBaseUrl = function (id) { };
    /**
     * @param {?} id
     * @return {?}
     */
    ConfigAspect.prototype.getConfig = function (id) { };
    /**
     * @return {?}
     */
    ConfigAspect.prototype.loadConfig = function () { };
    /**
     * @param {?} id
     * @return {?}
     */
    ConfigAspect.prototype.formatUrl = function (id) { };
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function Pager() { }
if (false) {
    /** @type {?} */
    Pager.prototype.pageSize;
    /** @type {?} */
    Pager.prototype.firstResult;
}
/**
 * @record
 */
function InfoFilter() { }
if (false) {
    /** @type {?|undefined} */
    InfoFilter.prototype.name;
    /** @type {?|undefined} */
    InfoFilter.prototype.shortName;
}
/**
 * @record
 */
function BaseFilter() { }
/**
 * @record
 */
function TableFilter() { }
if (false) {
    /** @type {?|undefined} */
    TableFilter.prototype.keyword;
    /** @type {?|undefined} */
    TableFilter.prototype.orderDir;
    /** @type {?|undefined} */
    TableFilter.prototype.orderBy;
    /** @type {?|undefined} */
    TableFilter.prototype.pager;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 * @template P
 */
function ChainEvent() { }
if (false) {
    /** @type {?|undefined} */
    ChainEvent.prototype.timeStamp;
    /** @type {?|undefined} */
    ChainEvent.prototype.name;
    /** @type {?|undefined} */
    ChainEvent.prototype.module;
    /** @type {?|undefined} */
    ChainEvent.prototype.tx;
    /** @type {?|undefined} */
    ChainEvent.prototype.payload;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function AccessRights() { }
if (false) {
    /** @type {?|undefined} */
    AccessRights.prototype.readUsers;
    /** @type {?|undefined} */
    AccessRights.prototype.writeUsers;
    /** @type {?|undefined} */
    AccessRights.prototype.readGroups;
    /** @type {?|undefined} */
    AccessRights.prototype.writeGroups;
}
/**
 * @record
 */
function AccessRightsFilter() { }

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function Change() { }
if (false) {
    /** @type {?} */
    Change.prototype.userId;
    /** @type {?} */
    Change.prototype.date;
}
/**
 * @record
 */
function Changed() { }
if (false) {
    /** @type {?|undefined} */
    Changed.prototype.change;
}
/**
 * @record
 */
function Created() { }
if (false) {
    /** @type {?|undefined} */
    Created.prototype.created;
}
/**
 * @record
 */
function ChangeFilter() { }
if (false) {
    /** @type {?|undefined} */
    ChangeFilter.prototype.userId;
    /** @type {?} */
    ChangeFilter.prototype.date;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function EntityFilter() { }
if (false) {
    /** @type {?|undefined} */
    EntityFilter.prototype.key;
}
/**
 * @record
 */
function ChainKey() { }
if (false) {
    /** @type {?|undefined} */
    ChainKey.prototype.module;
    /** @type {?|undefined} */
    ChainKey.prototype.entity;
    /** @type {?|undefined} */
    ChainKey.prototype.id;
}
/**
 * @record
 * @template P
 */
function ChainEntityEvent() { }
if (false) {
    /** @type {?|undefined} */
    ChainEntityEvent.prototype.key;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {string} */
var Type = {
    FILE: "FILE",
    DIRECTORY: 'DIRECTORY',
};
/**
 * @record
 */
function FileInfo() { }
if (false) {
    /** @type {?|undefined} */
    FileInfo.prototype.fileId;
    /** @type {?|undefined} */
    FileInfo.prototype.fileName;
    /** @type {?|undefined} */
    FileInfo.prototype.type;
    /** @type {?|undefined} */
    FileInfo.prototype.parentId;
    /** @type {?|undefined} */
    FileInfo.prototype.mime;
    /** @type {?} */
    FileInfo.prototype.tags;
}
/**
 * @record
 */
function FileInfoFilter() { }
if (false) {
    /** @type {?|undefined} */
    FileInfoFilter.prototype.fileId;
    /** @type {?|undefined} */
    FileInfoFilter.prototype.fileName;
    /** @type {?|undefined} */
    FileInfoFilter.prototype.types;
    /** @type {?|undefined} */
    FileInfoFilter.prototype.parentId;
    /** @type {?|undefined} */
    FileInfoFilter.prototype.tags;
    /** @type {?|undefined} */
    FileInfoFilter.prototype.accessFilter;
    /** @type {?|undefined} */
    FileInfoFilter.prototype.change;
    /** @type {?|undefined} */
    FileInfoFilter.prototype.created;
}
/**
 * @record
 */
function FileEvent() { }

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function InfoProvider() { }
if (false) {
    /** @type {?|undefined} */
    InfoProvider.prototype.info;
}
/**
 * @record
 */
function Info() { }
if (false) {
    /** @type {?|undefined} */
    Info.prototype.name;
    /** @type {?|undefined} */
    Info.prototype.shortName;
    /** @type {?|undefined} */
    Info.prototype.desc;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ChainContext = /** @class */ (function () {
    function ChainContext(data) {
        this.init(data);
    }
    /**
     * @protected
     * @param {?} data
     * @return {?}
     */
    ChainContext.prototype.init = /**
     * @protected
     * @param {?} data
     * @return {?}
     */
    function (data) {
        Object.assign(this, data);
        for (var idx = 0; idx < this.modules.length; idx++) {
            /** @type {?} */
            var module = this.modules[idx];
            module.apiUrl = module.apiUrl || this.baseUrl + '/' + module.reg;
        }
    };
    return ChainContext;
}());
if (false) {
    /** @type {?} */
    ChainContext.prototype.name;
    /** @type {?} */
    ChainContext.prototype.shortName;
    /** @type {?} */
    ChainContext.prototype.desc;
    /** @type {?} */
    ChainContext.prototype.baseUrl;
    /** @type {?} */
    ChainContext.prototype.tokenUrl;
    /** @type {?} */
    ChainContext.prototype.modules;
}
/**
 * @record
 */
function ModuleInfo() { }
if (false) {
    /** @type {?} */
    ModuleInfo.prototype.reg;
    /** @type {?|undefined} */
    ModuleInfo.prototype.name;
    /** @type {?|undefined} */
    ModuleInfo.prototype.desc;
    /** @type {?|undefined} */
    ModuleInfo.prototype.apiUrl;
    /** @type {?} */
    ModuleInfo.prototype.aspects;
}
/**
 * @record
 */
function AspectInfo() { }
if (false) {
    /** @type {?|undefined} */
    AspectInfo.prototype.name;
    /** @type {?} */
    AspectInfo.prototype.shortName;
    /** @type {?|undefined} */
    AspectInfo.prototype.desc;
    /** @type {?|undefined} */
    AspectInfo.prototype.apiUrl;
    /** @type {?|undefined} */
    AspectInfo.prototype.requests;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function GeoLocation() { }
if (false) {
    /** @type {?} */
    GeoLocation.prototype.latitude;
    /** @type {?} */
    GeoLocation.prototype.longitude;
    /** @type {?} */
    GeoLocation.prototype.altitude;
}
/**
 * @record
 */
function Address() { }
if (false) {
    /** @type {?|undefined} */
    Address.prototype.street;
    /** @type {?|undefined} */
    Address.prototype.streetNumber;
    /** @type {?|undefined} */
    Address.prototype.country;
    /** @type {?|undefined} */
    Address.prototype.zip;
    /** @type {?|undefined} */
    Address.prototype.city;
    /** @type {?|undefined} */
    Address.prototype.type;
    /** @type {?|undefined} */
    Address.prototype.desc;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 * @template V
 */
function Range() { }
if (false) {
    /** @type {?|undefined} */
    Range.prototype.from;
    /** @type {?|undefined} */
    Range.prototype.to;
}
/**
 * @record
 */
function IntRange() { }
/**
 * @record
 */
function DateRange() { }

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {number} */
var DetailLevel = {
    DEBUG: 0,
    INFO: 1,
    WARN: 2,
    ERROR: 3,
    FATAL: 30,
    MAX: 9999,
};
DetailLevel[DetailLevel.DEBUG] = 'DEBUG';
DetailLevel[DetailLevel.INFO] = 'INFO';
DetailLevel[DetailLevel.WARN] = 'WARN';
DetailLevel[DetailLevel.ERROR] = 'ERROR';
DetailLevel[DetailLevel.FATAL] = 'FATAL';
DetailLevel[DetailLevel.MAX] = 'MAX';
/** @enum {string} */
var ResultCode = {
    OK: "OK",
    IO: "IO",
    VALID: "VALID",
    INVALID: "INVALID",
    DUPLICATE: "DUPLICATE",
    DATA_ACCESS: "DATA_ACCESS",
    NOT_FOUND: "NOT_FOUND",
    UNKNOWN: "UNKNOWN",
    DELETE: "DELETE",
};
/**
 * @record
 */
function ResultDetail() { }
if (false) {
    /** @type {?} */
    ResultDetail.prototype.text;
    /** @type {?} */
    ResultDetail.prototype.code;
    /** @type {?} */
    ResultDetail.prototype.type;
    /** @type {?} */
    ResultDetail.prototype.level;
}
/**
 * @abstract
 */
var  /**
 * @abstract
 */
AbstractResult = /** @class */ (function () {
    function AbstractResult(data) {
        this.messages = [];
        Object.assign(this, data);
    }
    /*  public constructor(operation: string, fqn: string) {
          this.operation = operation;
          this.fqn = fqn;
          this.stamp = new Date();
      }*/
    /*  public constructor(operation: string, fqn: string) {
            this.operation = operation;
            this.fqn = fqn;
            this.stamp = new Date();
        }*/
    /**
     * @return {?}
     */
    AbstractResult.prototype.hasError = /*  public constructor(operation: string, fqn: string) {
            this.operation = operation;
            this.fqn = fqn;
            this.stamp = new Date();
        }*/
    /**
     * @return {?}
     */
    function () {
        return this.findDetail();
    };
    /**
     * @return {?}
     */
    AbstractResult.prototype.hasWarn = /**
     * @return {?}
     */
    function () {
        return this.findDetail(DetailLevel.WARN, DetailLevel.ERROR);
    };
    /**
     * @param {?=} minLevel
     * @param {?=} maxLevel
     * @return {?}
     */
    AbstractResult.prototype.findDetail = /**
     * @param {?=} minLevel
     * @param {?=} maxLevel
     * @return {?}
     */
    function (minLevel, maxLevel) {
        if (minLevel === void 0) { minLevel = DetailLevel.ERROR; }
        if (maxLevel === void 0) { maxLevel = DetailLevel.MAX; }
        /** @type {?} */
        var details = this.messages;
        if (details) {
            for (var i = 0; i < details.length; i++) {
                /** @type {?} */
                var msg = details[i];
                //console.log("AbstractResult findDetail [%d,%d] %o ", minLevel, maxLevel, msg);
                if (msg.level >= minLevel && msg.level <= maxLevel)
                    return msg;
            }
        }
        return null;
    };
    /**
     * @return {?}
     */
    AbstractResult.prototype.findMaxDetail = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var max = null;
        /** @type {?} */
        var details = this.messages;
        if (details != null && details.length) {
            max = details[0];
            for (var idx = 0; idx < details.length; idx++) {
                /** @type {?} */
                var detail = details[idx];
                if (detail.level >= max.level) {
                    max = detail;
                }
            }
        }
        return max;
    };
    /**
     * @param {?} text
     * @param {?=} code
     * @param {?=} type
     * @return {?}
     */
    AbstractResult.prototype.error = /**
     * @param {?} text
     * @param {?=} code
     * @param {?=} type
     * @return {?}
     */
    function (text, code, type) {
        if (code === void 0) { code = null; }
        if (type === void 0) { type = null; }
        /** @type {?} */
        var detail = (/** @type {?} */ ({ text: text, code: code, type: type, level: DetailLevel.ERROR }));
        this.messages.push(detail);
        return detail;
        // return new ResultDetail(text, code, type, DetailLevel.ERROR);
    };
    /**
     * @param {?} text
     * @param {?=} code
     * @param {?=} type
     * @return {?}
     */
    AbstractResult.prototype.warn = /**
     * @param {?} text
     * @param {?=} code
     * @param {?=} type
     * @return {?}
     */
    function (text, code, type) {
        if (code === void 0) { code = null; }
        if (type === void 0) { type = null; }
        /** @type {?} */
        var detail = (/** @type {?} */ ({ text: text, code: code, type: type, level: DetailLevel.WARN }));
        this.messages.push(detail);
        return detail;
    };
    /**
     * @param {?} text
     * @param {?=} code
     * @param {?=} type
     * @return {?}
     */
    AbstractResult.prototype.info = /**
     * @param {?} text
     * @param {?=} code
     * @param {?=} type
     * @return {?}
     */
    function (text, code, type) {
        if (code === void 0) { code = null; }
        if (type === void 0) { type = null; }
        /** @type {?} */
        var detail = (/** @type {?} */ ({ text: text, code: code, type: type, level: DetailLevel.INFO }));
        this.messages.push(detail);
        return detail;
    };
    /**
     * @param {?} text
     * @param {?=} type
     * @return {?}
     */
    AbstractResult.prototype.ok = /**
     * @param {?} text
     * @param {?=} type
     * @return {?}
     */
    function (text, type) {
        /** @type {?} */
        var detail = (/** @type {?} */ ({ text: text, code: ResultCode.OK, type: type, level: DetailLevel.INFO }));
        this.messages.push(detail);
        return detail;
    };
    /**
     * @param {?} data
     * @return {?}
     */
    AbstractResult.fromData = /**
     * @param {?} data
     * @return {?}
     */
    function (data) {
        //console.log("Setting", "fromData => ", data);
        // [ww] hack: fallback
        // noinspection TypeScriptValidateTypes
        //return new AbstractResult(data);
        throw new Error("");
    };
    return AbstractResult;
}());
if (false) {
    /** @type {?} */
    AbstractResult.prototype.operation;
    /** @type {?} */
    AbstractResult.prototype.fqn;
    /** @type {?} */
    AbstractResult.prototype.messages;
    /** @type {?} */
    AbstractResult.prototype.stamp;
}
var EditResult = /** @class */ (function (_super) {
    __extends(EditResult, _super);
    function EditResult(data) {
        return _super.call(this, data) || this;
    }
    /*  constructor(key: string, operation: string, fqn: string) {
        super(operation, fqn);
        this.key = key;
    }*/
    /*  constructor(key: string, operation: string, fqn: string) {
            super(operation, fqn);
            this.key = key;
        }*/
    /**
     * @param {?} data
     * @return {?}
     */
    EditResult.fromData = /*  constructor(key: string, operation: string, fqn: string) {
            super(operation, fqn);
            this.key = key;
        }*/
    /**
     * @param {?} data
     * @return {?}
     */
    function (data) {
        //console.log("Setting", "fromData => ", data);
        return new EditResult(data);
    };
    return EditResult;
}(AbstractResult));
if (false) {
    /** @type {?} */
    EditResult.prototype.key;
}
/**
 * @template E
 */
var  /**
 * @template E
 */
QueryResult = /** @class */ (function (_super) {
    __extends(QueryResult, _super);
    function QueryResult(data) {
        var _this = _super.call(this, data) || this;
        _this.items = [];
        _this.items = data.items;
        return _this;
    }
    /**
     * @template E
     * @param {?} data
     * @return {?}
     */
    QueryResult.fromData = /**
     * @template E
     * @param {?} data
     * @return {?}
     */
    function (data) {
        return new QueryResult(data);
    };
    return QueryResult;
}(AbstractResult));
if (false) {
    /** @type {?} */
    QueryResult.prototype.items;
    /** @type {?} */
    QueryResult.prototype.rows;
    /** @type {?} */
    QueryResult.prototype.hasMore;
}
var ErrorResult = /** @class */ (function (_super) {
    __extends(ErrorResult, _super);
    function ErrorResult(data) {
        return _super.call(this, data) || this;
    }
    /**
     * @param {?} data
     * @return {?}
     */
    ErrorResult.fromData = /**
     * @param {?} data
     * @return {?}
     */
    function (data) {
        return new ErrorResult(data);
    };
    return ErrorResult;
}(AbstractResult));
if (false) {
    /** @type {?} */
    ErrorResult.prototype.exception;
}
/**
 * elastic search result
 * @record
 * @template E
 */
function SearchResult() { }
if (false) {
    /** @type {?|undefined} */
    SearchResult.prototype.total;
    /** @type {?|undefined} */
    SearchResult.prototype.took;
    /** @type {?|undefined} */
    SearchResult.prototype.timedOut;
    /** @type {?} */
    SearchResult.prototype.rows;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { AbstractResult, ChainContext, DetailLevel, EditResult, ErrorResult, QueryResult, ResultCode, Type };
//# sourceMappingURL=yukawa-chain-base-angular-domain.js.map
